package org.minecms.dyneco;

import java.sql.SQLException;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

public class CommandHandler {
	public DynEco dyneco;
	EconomyHandler ecoHandler;
	private String item;
	ItemDb itemDB;

	public CommandHandler(DynEco dynEco) throws SQLException {
		dyneco = dynEco;

		itemDB = new ItemDb(dyneco);
		ecoHandler = dyneco.ecoHandler;

	}

	public boolean handle(final CommandSender sender, final Command command,
			final String commandLabel, final String[] args) {
		if (sender instanceof Player) {
			if (command.getLabel().equals("ecoreload")) {
				dyneco.reload();
			}
			if (command.getLabel().equals("value")) {
				ItemStack stack = null;
				if (args.length > 0) {
					stack = itemDB.get(args[0]);
					item = stack.getType().name().replace("_", " ")
							.toLowerCase();
				} else {
					stack = ((Player) sender).getInventory().getItemInHand();
					item = stack.getType().name().replace("_", " ")
							.toLowerCase();
				}

				sender.sendMessage(ChatColor.GREEN + "You can sell "
						+ ChatColor.AQUA + item + ChatColor.GREEN + " for "
						+ ChatColor.RED + "$"
						+ ecoHandler.getCurrentSellValue(stack)
						+ ChatColor.GREEN + " per block.");
				sender.sendMessage(ChatColor.GREEN + "You can buy "
						+ ChatColor.AQUA + item + ChatColor.GREEN + " for"
						+ ChatColor.RED + " $"
						+ ecoHandler.getCurrentBuyValue(stack)
						+ ChatColor.GREEN + " per block.");
			}

			if (command.getLabel().equals("sell")) {
				ItemStack stack = ((Player) sender).getInventory()
						.getItemInHand();
				ecoHandler.sellStack(stack, (Player) sender);
				return true;

			}
			if (command.getLabel().equals("buy")) {
				ItemStack stack = itemDB.get(args[0]);
				if (args.length == 1)
					stack.setAmount(64);
				else if (1 < args.length && args.length < 3)
					stack.setAmount(Integer.valueOf(args[1]));
				else
					return false;
				ecoHandler.buyStack(stack, (Player) sender);
			}
		} else {
			if (command.getLabel().equals("value")) {
				ItemStack stack = null;
				if (args.length > 0) {
					stack = itemDB.get(args[0]);
					item = stack.getType().name().replace("_", " ")
							.toLowerCase();
				} else {
					return false;
				}

				sender.sendMessage(ChatColor.GREEN + "You can sell "
						+ ChatColor.AQUA + item + ChatColor.GREEN + " for "
						+ ChatColor.RED + "$"
						+ ecoHandler.getCurrentSellValue(stack)
						+ ChatColor.GREEN + " per item.");
				sender.sendMessage(ChatColor.GREEN + "You can buy "
						+ ChatColor.AQUA + item + ChatColor.GREEN + " for"
						+ ChatColor.RED + " $"
						+ ecoHandler.getCurrentBuyValue(stack)
						+ ChatColor.GREEN + " per item.");
			} else
				sender.sendMessage(ChatColor.RED
						+ "Only players can use the command '"
						+ command.getLabel() + "'");
		}
		return true;
	}
}
